%define provider_dir %{_libdir}/cmpi

Name:           sblim-cmpi-service
Version:        0.8.2
Release:        3%{?dist}
Summary:        SBLIM Services provider

Group:          Applications/System
License:        CPL
URL:            http://sblim.wiki.sourceforge.net/
Source0:        http://downloads.sourceforge.net/sblim/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libtool
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  sblim-cmpi-base-devel >= 1.5 sblim-cmpi-devel
Requires:       sblim-cmpi-base >= 1.5 cim-server cim-schema

Patch100:       nopthreads.patch
Patch101:       script-path.patch
Patch102:       method-invocation.patch
Patch103:       getproperty.patch

%description
Standards Based Linux Instrumentation Base Service CMPI Providers for System-related CIM classes

%package        devel
Summary:        SBLIM Service Instrumentation Header Development Files
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
SBLIM Base Service Provider Development Package contains header files and link libraries for dependent provider packages

%prep
%setup -q
%patch100 -p1 -b .nopthreads
%patch101 -p1 -b .script-path
%patch102 -p1 -b .method-invocation
%patch103 -p1 -b .getproperty

autoreconf -i

%build
%ifarch s390 s390x ppc ppc64
export CFLAGS="$RPM_OPT_FLAGS -fsigned-char"
%else
export CFLAGS="$RPM_OPT_FLAGS"
%endif
%configure \
        --disable-static \
        PROVIDERDIR=%{provider_dir}
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
# remove unused libtool files
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT/%{provider_dir}/*.la
# shared libraries
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/ld.so.conf.d
echo "%{_libdir}/cmpi" > $RPM_BUILD_ROOT/%{_sysconfdir}/ld.so.conf.d/%{name}-%{_arch}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%docdir %{_datadir}/doc/%{name}-%{version}
%{_datadir}/%{name}
%{_datadir}/doc/%{name}-%{version}
%{_datadir}/%{name}/listservices
%{_libdir}/*.so.*
%{provider_dir}/*.so
%{provider_dir}/*.so.*
%config(noreplace) %{_sysconfdir}/ld.so.conf.d/%{name}-%{_arch}.conf

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so
%{_datadir}/doc/%{name}-%{version}

%define PEGASUS_MOF CIM_Service

%pre
if [ "$1" -gt 1 ]; then
# If upgrading, deregister old version
    %{_datadir}/%{name}/provider-register.sh -d \
        -m %{_datadir}/%{name}/*.mof \
        -r %{_datadir}/%{name}/*.registration \
        > /dev/null 2>&1 || :;
fi

%post
/sbin/ldconfig
# Register Schema and Provider - this is higly provider specific  
# tog-pegasus needs some schemes registered first  
if [ -x /usr/bin/peg-loadmof.sh ]; then
   peg-loadmof.sh -n root/cimv2 /usr/share/mof/cim-current/*/{%{PEGASUS_MOF}}.mof > /dev/null 2>&1 || :;
   /sbin/service tog-pegasus try-restart > /dev/null 2>&1 || :;
fi
if [ "$1" -ge 1 ]; then
# Register Schema and Provider
    %{_datadir}/%{name}/provider-register.sh \
        -m %{_datadir}/%{name}/*.mof \
        -r %{_datadir}/%{name}/*.registration \
        > /dev/null 2>&1 || :;
fi

%preun
if [ "$1" -eq 0 ]; then
# Deregister only if not upgrading
    %{_datadir}/%{name}/provider-register.sh -d \
        -m %{_datadir}/%{name}/*.mof \
        -r %{_datadir}/%{name}/*.registration \
        > /dev/null 2>&1 || :;
fi

%postun -p /sbin/ldconfig

%changelog
* Thu Mar 22 2012 Zane Bitter <zbitter@redhat.com> - 0.8.2-3
- Implement getProperty

* Thu Mar 15 2012 Zane Bitter <zbitter@redhat.com> - 0.8.2-2
- Allowed method invocations

* Tue Feb 21 2012 Zane Bitter <zbitter@redhat.com> - 0.8.2-1
- Initial support
